/*!
ng-dynamic-forms 1.4.31 2017-09-14 13:09 UTC
Copyright (c) 2016-2017, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ng-dynamic-forms/core'), require('@angular/material'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@ng-dynamic-forms/core', '@angular/material', '@angular/common'], factory) :
	(factory((global.ng2DF = global.ng2DF || {}, global.ng2DF.uiMaterial = {}),global.ng.core,global.ng.forms,global.ngDF.core,global.ng.material,global.ng.common));
}(this, (function (exports,core,forms,core$1,material,common) { 'use strict';

var MD_VIEW_CHILD_SELECTOR = "mdAutocomplete,mdCheckbox,mdDatepicker,mdInput,mdRadioGroup,mdSelect,\n    mdSlider,mdSlideToggle,mdTextarea";

var __extends$1 = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$1 = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var DynamicMaterialFormControlComponent = /** @class */ (function (_super) {
    __extends$1(DynamicMaterialFormControlComponent, _super);
    function DynamicMaterialFormControlComponent(changeDetectorRef, validationService) {
        var _this = _super.call(this, changeDetectorRef, validationService) || this;
        _this.changeDetectorRef = changeDetectorRef;
        _this.validationService = validationService;
        _this._showCharacterCount = false;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new core.EventEmitter();
        _this.change = new core.EventEmitter();
        _this.focus = new core.EventEmitter();
        return _this;
    }
    DynamicMaterialFormControlComponent_1 = DynamicMaterialFormControlComponent;
    Object.defineProperty(DynamicMaterialFormControlComponent.prototype, "showCharacterHint", {
        get: function () {
            return !!(this._showCharacterCount && this.model.maxLength && this.characterCount);
        },
        set: function (value) {
            this._showCharacterCount = value;
        },
        enumerable: true,
        configurable: true
    });
    DynamicMaterialFormControlComponent.prototype.ngOnChanges = function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (changes["model"]) {
            this.type = DynamicMaterialFormControlComponent_1.getFormControlType(this.model);
        }
    };
    Object.defineProperty(DynamicMaterialFormControlComponent.prototype, "characterCount", {
        get: function () {
            return this.mdInput ? this.mdInput.value.length : null;
        },
        enumerable: true,
        configurable: true
    });
    DynamicMaterialFormControlComponent.getFormControlType = function (model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return 1 /* Array */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return 2 /* Checkbox */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return 4 /* Group */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return 3 /* DatePicker */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return 5 /* Input */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return 6 /* RadioGroup */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return 7 /* Select */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SLIDER:
                return 8 /* Slider */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
                return 9 /* SlideToggle */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return 10 /* TextArea */;
            default:
                return null;
        }
    };
    __decorate$1([
        core.ContentChildren(core$1.DynamicTemplateDirective),
        __metadata$1("design:type", core.QueryList)
    ], DynamicMaterialFormControlComponent.prototype, "contentTemplates", void 0);
    __decorate$1([
        core.Input("templates"),
        __metadata$1("design:type", core.QueryList)
    ], DynamicMaterialFormControlComponent.prototype, "inputTemplates", void 0);
    __decorate$1([
        core.Input(),
        __metadata$1("design:type", Boolean)
    ], DynamicMaterialFormControlComponent.prototype, "bindId", void 0);
    __decorate$1([
        core.Input(),
        __metadata$1("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "context", void 0);
    __decorate$1([
        core.Input(),
        __metadata$1("design:type", forms.FormGroup)
    ], DynamicMaterialFormControlComponent.prototype, "group", void 0);
    __decorate$1([
        core.Input(),
        __metadata$1("design:type", Boolean)
    ], DynamicMaterialFormControlComponent.prototype, "hasErrorMessaging", void 0);
    __decorate$1([
        core.Input(),
        __metadata$1("design:type", core$1.DynamicFormControlModel)
    ], DynamicMaterialFormControlComponent.prototype, "model", void 0);
    __decorate$1([
        core.Input(),
        __metadata$1("design:type", Boolean),
        __metadata$1("design:paramtypes", [Boolean])
    ], DynamicMaterialFormControlComponent.prototype, "showCharacterHint", null);
    __decorate$1([
        core.Output(),
        __metadata$1("design:type", core.EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "blur", void 0);
    __decorate$1([
        core.Output(),
        __metadata$1("design:type", core.EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "change", void 0);
    __decorate$1([
        core.Output(),
        __metadata$1("design:type", core.EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "focus", void 0);
    __decorate$1([
        core.ViewChild(MD_VIEW_CHILD_SELECTOR),
        __metadata$1("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "mdViewChild", void 0);
    __decorate$1([
        core.ViewChild(material.MdInput),
        __metadata$1("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "mdInput", void 0);
    DynamicMaterialFormControlComponent = DynamicMaterialFormControlComponent_1 = __decorate$1([
        core.Component({
            selector: "dynamic-material-form-control,dynamic-form-material-control",
            template: "<div [formGroup]=\"group\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\"><label *ngIf=\"model.label && type !== 2\" [attr.for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\"></label><ng-container *ngIf=\"type !== 1 && template?.align === 'START'\"><ng-container *ngTemplateOutlet=\"template?.templateRef; context: model\"></ng-container></ng-container><ng-container [ngSwitch]=\"type\"><div *ngSwitchCase=\"1\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\"><div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\" [formGroupName]=\"idx\" [ngClass]=\"[model.cls.element.group, model.cls.grid.group]\"><dynamic-material-form-control *ngFor=\"let controlModel of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [templates]=\"templates\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-material-form-control><ng-container *ngTemplateOutlet=\"template?.templateRef; context: groupModel\"></ng-container></div></div><md-checkbox *ngSwitchCase=\"2\" #mdCheckbox [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [indeterminate]=\"model.indeterminate\" [labelPosition]=\"model.labelPosition\" [name]=\"model.name\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><span [ngClass]=\"model.cls.element.label\" [innerHTML]=\"model.label\"></span></md-checkbox><md-form-field *ngSwitchCase=\"3\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\"><input mdInput [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [max]=\"model.max\" [mdDatepicker]=\"mdDatepicker\" [min]=\"model.min\" [name]=\"model.name\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><md-datepicker-toggle mdSuffix [for]=\"mdDatepicker\"></md-datepicker-toggle><md-datepicker #mdDatepicker [startAt]=\"model.focusedDate\" [touchUi]=\"true\" (selectedChanged)=\"onValueChange($event)\"></md-datepicker></md-form-field><div *ngSwitchCase=\"4\" role=\"group\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\"><dynamic-material-form-control *ngFor=\"let controlModel of model.group\" [group]=\"control\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [templates]=\"templates\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-material-form-control></div><ng-container *ngSwitchCase=\"5\"><md-form-field #mdInput [ngClass]=\"model.cls.grid.control\"><span *ngIf=\"model.prefix\" mdPrefix [innerHTML]=\"model.prefix\"></span> <input mdInput [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [mdAutocomplete]=\"mdAutocomplete\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"> <span *ngIf=\"model.suffix\" mdSuffix [innerHTML]=\"model.suffix\"></span><md-hint *ngIf=\"model.hint\" align=\"start\" [innerHTML]=\"model.hint\"></md-hint><md-hint *ngIf=\"showCharacterHint\" align=\"end\">{{characterCount}} / {{model.maxLength}}</md-hint><md-error *ngFor=\"let message of errorMessages\"><span *ngIf=\"showErrorMessages\">{{message}}</span></md-error></md-form-field><md-autocomplete #mdAutocomplete=\"mdAutocomplete\"><md-option *ngFor=\"let option of model.list\" [value]=\"option\">{{ option }}</md-option></md-autocomplete></ng-container><md-radio-group *ngSwitchCase=\"6\" #mdRadioGroup [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><md-radio-button *ngFor=\"let option of model.options$ | async\" [labelPosition]=\"'after'\" [name]=\"model.name\" [ngClass]=\"model.cls.element.option\" [value]=\"option.value\"><span [innerHTML]=\"option.label\"></span></md-radio-button></md-radio-group><md-select *ngSwitchCase=\"7\" #mdSelect [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [multiple]=\"model.multiple\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" [placeholder]=\"model.placeholder\" (change)=\"onValueChange($event)\"><md-option *ngFor=\"let option of model.options$ | async\" [ngClass]=\"model.cls.element.option\" [value]=\"option.value\"><span [innerHTML]=\"option.label\"></span></md-option></md-select><md-slider *ngSwitchCase=\"8\" #mdSlider [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [min]=\"model.min\" [max]=\"model.max\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" [step]=\"model.step\" [thumbLabel]=\"true\" tickInterval=\"1\" [vertical]=\"model.vertical\" (change)=\"onValueChange($event)\"></md-slider><md-slide-toggle *ngSwitchCase=\"9\" #mdSlideToggle [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [labelPosition]=\"model.labelPosition\" [name]=\"model.name\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" (change)=\"onValueChange($event)\"><span *ngIf=\"!model.checked\" [innerHTML]=\"model.offLabel\"></span> <span *ngIf=\"model.checked\" [innerHTML]=\"model.onLabel\"></span></md-slide-toggle><md-form-field *ngSwitchCase=\"10\" #mdTextarea [ngClass]=\"model.cls.grid.control\"><textarea mdInput [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></textarea><md-hint *ngIf=\"model.hint\" align=\"start\" [innerHTML]=\"model.hint\"></md-hint><md-hint *ngIf=\"showCharacterHint\" align=\"end\">{{characterCount}} / {{model.maxLength}}</md-hint><md-error *ngFor=\"let message of errorMessages\"><span *ngIf=\"showErrorMessages\">{{message}}</span></md-error></md-form-field></ng-container><ng-container *ngIf=\"type !== 5 && type !== 10 && showErrorMessages\"><md-error *ngFor=\"let message of errorMessages\">{{message}}</md-error></ng-container><ng-container *ngIf=\"type !== 1 && template?.align === 'END'\"><ng-container *ngTemplateOutlet=\"template?.templateRef; context: model\"></ng-container></ng-container></div>"
        }),
        __metadata$1("design:paramtypes", [core.ChangeDetectorRef,
            core$1.DynamicFormValidationService])
    ], DynamicMaterialFormControlComponent);
    return DynamicMaterialFormControlComponent;
    var DynamicMaterialFormControlComponent_1;
}(core$1.DynamicFormControlComponent));

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var DynamicMaterialFormComponent = /** @class */ (function (_super) {
    __extends(DynamicMaterialFormComponent, _super);
    function DynamicMaterialFormComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.blur = new core.EventEmitter();
        _this.change = new core.EventEmitter();
        _this.focus = new core.EventEmitter();
        return _this;
    }
    __decorate([
        core.Input(),
        __metadata("design:type", forms.FormGroup)
    ], DynamicMaterialFormComponent.prototype, "group", void 0);
    __decorate([
        core.Input(),
        __metadata("design:type", Array)
    ], DynamicMaterialFormComponent.prototype, "model", void 0);
    __decorate([
        core.Output(),
        __metadata("design:type", core.EventEmitter)
    ], DynamicMaterialFormComponent.prototype, "blur", void 0);
    __decorate([
        core.Output(),
        __metadata("design:type", core.EventEmitter)
    ], DynamicMaterialFormComponent.prototype, "change", void 0);
    __decorate([
        core.Output(),
        __metadata("design:type", core.EventEmitter)
    ], DynamicMaterialFormComponent.prototype, "focus", void 0);
    __decorate([
        core.ContentChildren(core$1.DynamicTemplateDirective),
        __metadata("design:type", core.QueryList)
    ], DynamicMaterialFormComponent.prototype, "templates", void 0);
    __decorate([
        core.ViewChildren(DynamicMaterialFormControlComponent),
        __metadata("design:type", core.QueryList)
    ], DynamicMaterialFormComponent.prototype, "components", void 0);
    DynamicMaterialFormComponent = __decorate([
        core.Component({
            selector: "dynamic-material-form",
            template: "<dynamic-material-form-control *ngFor=\"let controlModel of model; trackBy: trackByFn\" [group]=\"group\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" [showCharacterHint]=\"controlModel.type === 'INPUT'\" [templates]=\"templates\" (blur)=\"onEvent($event, 0)\" (change)=\"onEvent($event, 1)\" (focus)=\"onEvent($event, 2)\"></dynamic-material-form-control>"
        })
    ], DynamicMaterialFormComponent);
    return DynamicMaterialFormComponent;
}(core$1.DynamicFormComponent));

var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var DynamicFormsMaterialUIModule = /** @class */ (function () {
    function DynamicFormsMaterialUIModule() {
    }
    DynamicFormsMaterialUIModule = __decorate$2([
        core.NgModule({
            imports: [
                common.CommonModule,
                forms.ReactiveFormsModule,
                material.MdAutocompleteModule,
                material.MdCheckboxModule,
                material.MdDatepickerModule,
                material.MdInputModule,
                material.MdRadioModule,
                material.MdSelectModule,
                material.MdSliderModule,
                material.MdSlideToggleModule,
                core$1.DynamicFormsCoreModule
            ],
            declarations: [
                DynamicMaterialFormControlComponent,
                DynamicMaterialFormComponent
            ],
            exports: [
                core$1.DynamicFormsCoreModule,
                DynamicMaterialFormControlComponent,
                DynamicMaterialFormComponent
            ]
        })
    ], DynamicFormsMaterialUIModule);
    return DynamicFormsMaterialUIModule;
}());

exports.DynamicMaterialFormComponent = DynamicMaterialFormComponent;
exports.MD_VIEW_CHILD_SELECTOR = MD_VIEW_CHILD_SELECTOR;
exports.DynamicMaterialFormControlComponent = DynamicMaterialFormControlComponent;
exports.DynamicFormsMaterialUIModule = DynamicFormsMaterialUIModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
