import { ChangeDetectorRef, EventEmitter, OnChanges, QueryList, SimpleChanges } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { MdAutocomplete, MdCheckbox, MdDatepicker, MdFormField, MdInput, MdRadioGroup, MdSelect, MdSlider, MdSlideToggle } from "@angular/material";
import { DynamicFormValidationService, DynamicFormControlComponent, DynamicFormControlModel, DynamicFormArrayGroupModel, DynamicFormControlEvent, DynamicTemplateDirective } from "@ng-dynamic-forms/core";
import { MdFormControlType } from "./dynamic-material-form.const";
export declare type MdFormControlComponent = MdAutocomplete | MdCheckbox | MdDatepicker<Date> | MdFormField | MdRadioGroup | MdSelect | MdSlider | MdSlideToggle;
export declare class DynamicMaterialFormControlComponent extends DynamicFormControlComponent implements OnChanges {
    protected changeDetectorRef: ChangeDetectorRef;
    protected validationService: DynamicFormValidationService;
    private _showCharacterCount;
    contentTemplates: QueryList<DynamicTemplateDirective>;
    inputTemplates: QueryList<DynamicTemplateDirective>;
    bindId: boolean;
    context: DynamicFormArrayGroupModel | null;
    group: FormGroup;
    hasErrorMessaging: boolean;
    model: DynamicFormControlModel;
    showCharacterHint: boolean;
    blur: EventEmitter<DynamicFormControlEvent>;
    change: EventEmitter<DynamicFormControlEvent>;
    focus: EventEmitter<DynamicFormControlEvent>;
    mdViewChild: MdFormControlComponent | undefined;
    mdInput: MdInput | undefined;
    type: MdFormControlType | null;
    constructor(changeDetectorRef: ChangeDetectorRef, validationService: DynamicFormValidationService);
    ngOnChanges(changes: SimpleChanges): void;
    readonly characterCount: number | null;
    static getFormControlType(model: DynamicFormControlModel): MdFormControlType | null;
}
