var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ChangeDetectorRef, Component, ContentChildren, EventEmitter, Input, Output, QueryList, ViewChild } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { MdInput } from "@angular/material";
import { DynamicFormValidationService, DynamicFormControlComponent, DynamicFormControlModel, DynamicTemplateDirective, DYNAMIC_FORM_CONTROL_TYPE_ARRAY, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP, DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER, DYNAMIC_FORM_CONTROL_TYPE_GROUP, DYNAMIC_FORM_CONTROL_TYPE_INPUT, DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP, DYNAMIC_FORM_CONTROL_TYPE_SELECT, DYNAMIC_FORM_CONTROL_TYPE_SLIDER, DYNAMIC_FORM_CONTROL_TYPE_SWITCH, DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA } from "@ng-dynamic-forms/core";
import { MD_VIEW_CHILD_SELECTOR } from "./dynamic-material-form.const";
var DynamicMaterialFormControlComponent = /** @class */ (function (_super) {
    __extends(DynamicMaterialFormControlComponent, _super);
    function DynamicMaterialFormControlComponent(changeDetectorRef, validationService) {
        var _this = _super.call(this, changeDetectorRef, validationService) || this;
        _this.changeDetectorRef = changeDetectorRef;
        _this.validationService = validationService;
        _this._showCharacterCount = false;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new EventEmitter();
        _this.change = new EventEmitter();
        _this.focus = new EventEmitter();
        return _this;
    }
    DynamicMaterialFormControlComponent_1 = DynamicMaterialFormControlComponent;
    Object.defineProperty(DynamicMaterialFormControlComponent.prototype, "showCharacterHint", {
        get: function () {
            return !!(this._showCharacterCount && this.model.maxLength && this.characterCount);
        },
        set: function (value) {
            this._showCharacterCount = value;
        },
        enumerable: true,
        configurable: true
    });
    DynamicMaterialFormControlComponent.prototype.ngOnChanges = function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (changes["model"]) {
            this.type = DynamicMaterialFormControlComponent_1.getFormControlType(this.model);
        }
    };
    Object.defineProperty(DynamicMaterialFormControlComponent.prototype, "characterCount", {
        get: function () {
            return this.mdInput ? this.mdInput.value.length : null;
        },
        enumerable: true,
        configurable: true
    });
    DynamicMaterialFormControlComponent.getFormControlType = function (model) {
        switch (model.type) {
            case DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return 1 /* Array */;
            case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return 2 /* Checkbox */;
            case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return 4 /* Group */;
            case DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return 3 /* DatePicker */;
            case DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return 5 /* Input */;
            case DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return 6 /* RadioGroup */;
            case DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return 7 /* Select */;
            case DYNAMIC_FORM_CONTROL_TYPE_SLIDER:
                return 8 /* Slider */;
            case DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
                return 9 /* SlideToggle */;
            case DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return 10 /* TextArea */;
            default:
                return null;
        }
    };
    __decorate([
        ContentChildren(DynamicTemplateDirective),
        __metadata("design:type", QueryList)
    ], DynamicMaterialFormControlComponent.prototype, "contentTemplates", void 0);
    __decorate([
        Input("templates"),
        __metadata("design:type", QueryList)
    ], DynamicMaterialFormControlComponent.prototype, "inputTemplates", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DynamicMaterialFormControlComponent.prototype, "bindId", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "context", void 0);
    __decorate([
        Input(),
        __metadata("design:type", FormGroup)
    ], DynamicMaterialFormControlComponent.prototype, "group", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DynamicMaterialFormControlComponent.prototype, "hasErrorMessaging", void 0);
    __decorate([
        Input(),
        __metadata("design:type", DynamicFormControlModel)
    ], DynamicMaterialFormControlComponent.prototype, "model", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], DynamicMaterialFormControlComponent.prototype, "showCharacterHint", null);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "blur", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "change", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "focus", void 0);
    __decorate([
        ViewChild(MD_VIEW_CHILD_SELECTOR),
        __metadata("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "mdViewChild", void 0);
    __decorate([
        ViewChild(MdInput),
        __metadata("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "mdInput", void 0);
    DynamicMaterialFormControlComponent = DynamicMaterialFormControlComponent_1 = __decorate([
        Component({
            selector: "dynamic-material-form-control,dynamic-form-material-control",
            template: "<div [formGroup]=\"group\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\"><label *ngIf=\"model.label && type !== 2\" [attr.for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\"></label><ng-container *ngIf=\"type !== 1 && template?.align === 'START'\"><ng-container *ngTemplateOutlet=\"template?.templateRef; context: model\"></ng-container></ng-container><ng-container [ngSwitch]=\"type\"><div *ngSwitchCase=\"1\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\"><div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\" [formGroupName]=\"idx\" [ngClass]=\"[model.cls.element.group, model.cls.grid.group]\"><dynamic-material-form-control *ngFor=\"let controlModel of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [templates]=\"templates\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-material-form-control><ng-container *ngTemplateOutlet=\"template?.templateRef; context: groupModel\"></ng-container></div></div><md-checkbox *ngSwitchCase=\"2\" #mdCheckbox [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [indeterminate]=\"model.indeterminate\" [labelPosition]=\"model.labelPosition\" [name]=\"model.name\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><span [ngClass]=\"model.cls.element.label\" [innerHTML]=\"model.label\"></span></md-checkbox><md-form-field *ngSwitchCase=\"3\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\"><input mdInput [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [max]=\"model.max\" [mdDatepicker]=\"mdDatepicker\" [min]=\"model.min\" [name]=\"model.name\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><md-datepicker-toggle mdSuffix [for]=\"mdDatepicker\"></md-datepicker-toggle><md-datepicker #mdDatepicker [startAt]=\"model.focusedDate\" [touchUi]=\"true\" (selectedChanged)=\"onValueChange($event)\"></md-datepicker></md-form-field><div *ngSwitchCase=\"4\" role=\"group\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\"><dynamic-material-form-control *ngFor=\"let controlModel of model.group\" [group]=\"control\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [templates]=\"templates\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-material-form-control></div><ng-container *ngSwitchCase=\"5\"><md-form-field #mdInput [ngClass]=\"model.cls.grid.control\"><span *ngIf=\"model.prefix\" mdPrefix [innerHTML]=\"model.prefix\"></span> <input mdInput [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [mdAutocomplete]=\"mdAutocomplete\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"> <span *ngIf=\"model.suffix\" mdSuffix [innerHTML]=\"model.suffix\"></span><md-hint *ngIf=\"model.hint\" align=\"start\" [innerHTML]=\"model.hint\"></md-hint><md-hint *ngIf=\"showCharacterHint\" align=\"end\">{{characterCount}} / {{model.maxLength}}</md-hint><md-error *ngFor=\"let message of errorMessages\"><span *ngIf=\"showErrorMessages\">{{message}}</span></md-error></md-form-field><md-autocomplete #mdAutocomplete=\"mdAutocomplete\"><md-option *ngFor=\"let option of model.list\" [value]=\"option\">{{ option }}</md-option></md-autocomplete></ng-container><md-radio-group *ngSwitchCase=\"6\" #mdRadioGroup [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><md-radio-button *ngFor=\"let option of model.options$ | async\" [labelPosition]=\"'after'\" [name]=\"model.name\" [ngClass]=\"model.cls.element.option\" [value]=\"option.value\"><span [innerHTML]=\"option.label\"></span></md-radio-button></md-radio-group><md-select *ngSwitchCase=\"7\" #mdSelect [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [multiple]=\"model.multiple\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" [placeholder]=\"model.placeholder\" (change)=\"onValueChange($event)\"><md-option *ngFor=\"let option of model.options$ | async\" [ngClass]=\"model.cls.element.option\" [value]=\"option.value\"><span [innerHTML]=\"option.label\"></span></md-option></md-select><md-slider *ngSwitchCase=\"8\" #mdSlider [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [min]=\"model.min\" [max]=\"model.max\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" [step]=\"model.step\" [thumbLabel]=\"true\" tickInterval=\"1\" [vertical]=\"model.vertical\" (change)=\"onValueChange($event)\"></md-slider><md-slide-toggle *ngSwitchCase=\"9\" #mdSlideToggle [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [labelPosition]=\"model.labelPosition\" [name]=\"model.name\" [ngClass]=\"[model.cls.element.control, model.cls.grid.control]\" (change)=\"onValueChange($event)\"><span *ngIf=\"!model.checked\" [innerHTML]=\"model.offLabel\"></span> <span *ngIf=\"model.checked\" [innerHTML]=\"model.onLabel\"></span></md-slide-toggle><md-form-field *ngSwitchCase=\"10\" #mdTextarea [ngClass]=\"model.cls.grid.control\"><textarea mdInput [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></textarea><md-hint *ngIf=\"model.hint\" align=\"start\" [innerHTML]=\"model.hint\"></md-hint><md-hint *ngIf=\"showCharacterHint\" align=\"end\">{{characterCount}} / {{model.maxLength}}</md-hint><md-error *ngFor=\"let message of errorMessages\"><span *ngIf=\"showErrorMessages\">{{message}}</span></md-error></md-form-field></ng-container><ng-container *ngIf=\"type !== 5 && type !== 10 && showErrorMessages\"><md-error *ngFor=\"let message of errorMessages\">{{message}}</md-error></ng-container><ng-container *ngIf=\"type !== 1 && template?.align === 'END'\"><ng-container *ngTemplateOutlet=\"template?.templateRef; context: model\"></ng-container></ng-container></div>"
        }),
        __metadata("design:paramtypes", [ChangeDetectorRef,
            DynamicFormValidationService])
    ], DynamicMaterialFormControlComponent);
    return DynamicMaterialFormControlComponent;
    var DynamicMaterialFormControlComponent_1;
}(DynamicFormControlComponent));
export { DynamicMaterialFormControlComponent };

//# sourceMappingURL=dynamic-material-form-control.component.js.map
